hdu 3486 Interviewe (二分+RMQ)

来源:互联网 发布:手机淘宝2015旧版本5.5 编辑:程序博客网 时间:2024/05/21 06:48

Interviewe

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 7381    Accepted Submission(s): 1759


Problem Description
YaoYao has a company and he wants to employ m people recently. Since his company is so famous, there are n people coming for the interview. However, YaoYao is so busy that he has no time to interview them by himself. So he decides to select exact m interviewers for this task.
YaoYao decides to make the interview as follows. First he queues the interviewees according to their coming order. Then he cuts the queue into m segments. The length of each segment is , which means he ignores the rest interviewees (poor guys because they comes late). Then, each segment is assigned to an interviewer and the interviewer chooses the best one from them as the employee.
YaoYao’s idea seems to be wonderful, but he meets another problem. He values the ability of the ith arrived interviewee as a number from 0 to 1000. Of course, the better one is, the higher ability value one has. He wants his employees good enough, so the sum of the ability values of his employees must exceed his target k (exceed means strictly large than). On the other hand, he wants to employ as less people as possible because of the high salary nowadays. Could you help him to find the smallest m?
 

Input
The input consists of multiple cases.
In the first line of each case, there are two numbers n and k, indicating the number of the original people and the sum of the ability values of employees YaoYao wants to hire (n≤200000, k≤1000000000). In the second line, there are n numbers v1, v2, …, vn (each number is between 0 and 1000), indicating the ability value of each arrived interviewee respectively.
The input ends up with two negative numbers, which should not be processed as a case.
 

Output
For each test case, print only one number indicating the smallest m you can find. If you can’t find any, output -1 instead.
 

Sample Input
11 3007 100 7 101 100 100 9 100 100 110 110-1 -1
 

Sample Output
3
Hint
We need 3 interviewers to help YaoYao. The first one interviews people from 1 to 3, the second interviews people from 4 to 6, and the third interviews people from 7 to 9. And the people left will be ignored. And the total value you can get is 100+101+100=301>300.
 

Source
2010 ACM-ICPC Multi-University Training Contest(5)——Host by BJTU 

分析:用RMQ的ST算法来记录最大值,然后假设x是满足条件的所需要选的人数,然后二分搜索,最后得出最优值

#include <iostream>#include <cstdio>#include <cstring>#include <cmath>#define MAX_N 200005using namespace std;int a[MAX_N],dp[MAX_N][30];bool jud(int x,int n,int k){    int len=n/x,sum=0;    int c=(int)(log(len)/log(2.0));    for(int i=0;i<x;i++)    {        sum+=max(dp[1+len*i][c],dp[1+(i+1)*len-(int)pow(2,c)][c]);    }    if(sum>k) return true;    return false;}int main(){    int n,k;    while(~scanf("%d%d",&n,&k))    {        if(n==-1&&k==-1) break;        for(int i=1;i<=n;i++)            scanf("%d",&a[i]);        for(int i=1;i<=n;i++)            dp[i][0]=a[i];        for(int j=1;(1<<j)<=n;j++)            for(int i=1;i+(1<<j)-1<=n;i++)                dp[i][j]=max(dp[i][j-1],dp[i+(1<<(j-1))][j-1]);        int l=n,r;        if(!jud(n,n,k)) printf("-1\n");        else        {            while(l>0&&jud(l,n,k)) r=l,l/=2; //注意l>0            while(r-l>1)            {                int mid=(l+r)/2;                if(jud(mid,n,k)) r=mid;                else l=mid;            }            printf("%d\n",++l);        }    }    return 0;}